/*
 * Copyright (c) 1979 Regents of the University of California
 * C shell
 *
 * @(#)sh.hist.c	3.1 of 5/22/85.
 */

static char sccsid[] = "@(#)sh.hist.c	3.1";

#include "sh.h"

savehist(sp)
	struct wordent *sp;
{
	register struct Hist *hp, *np;
	int histlen;
	register char *cp;

	cp = value("history");
	if (*cp == 0)
		histlen = 0;
	else {
		while (*cp && digit(*cp))
			cp++;
		/* avoid a looping snafu */
		if (*cp)
			set("history", "10");
		histlen = getn(value("history"));
	}
	/* throw away null lines */
	if (sp->next->word[0] == '\n')
		return;
	for (hp = &Histlist; np = hp->Hnext;)
		if (eventno - np->Href >= histlen || histlen == 0)
			hp->Hnext = np->Hnext, hfree(np);
		else
			hp = np;
	enthist(++eventno, sp, 1);
}

struct Hist *
enthist(event, lp, docopy)
	int event;
	register struct wordent *lp;
	bool docopy;
{
	register struct Hist *np;

	np = (struct Hist *) calloc(1, sizeof *np);
	np->Hnum = np->Href = event;
	if (docopy)
		copylex(&np->Hlex, lp);
	else {
		np->Hlex.next = lp->next;
		lp->next->prev = &np->Hlex;
		np->Hlex.prev = lp->prev;
		lp->prev->next = &np->Hlex;
	}
	np->Hnext = Histlist.Hnext;
	Histlist.Hnext = np;
	return (np);
}

hfree(hp)
	register struct Hist *hp;
{

	freelex(&hp->Hlex);
	xfree(hp);
}

dohist(vp)
  char **vp;
{
   register char * arg;
   register short int  limit = -1;
   register char flags = 0;

   if (getn(value("history")) == 0)
       return;

   for (arg = *++vp; arg; arg = *++vp)
    {
       if (*arg == '-')
	   switch (*++arg)
	    {
	    case 'r':
#define HIST_REV	0x01
	       flags |= HIST_REV;
	       break;
	    case 'h':
#define HIST_QUIET	0x02
	       flags |= HIST_QUIET;
	       break;
	    default:
	       error( "Illegal argument to history" );
	    }
       else 
	{
	   limit = 0;
	   while (*arg >= '0' && *arg <= '9')
	       limit = (limit * 10) + *arg++ - '0';
	   if (*arg)
	       error( "Illegal argument to history" );
	}
    }

   dohist1(Histlist.Hnext, limit, flags);
}

dohist1(hp, c, fl)
  register struct Hist *hp;
  register short int c;
  register char fl;
{

	if (hp == 0 || c == 0)
		return;
	hp->Href++;
	if (fl & HIST_REV)
	 {
	    phist(hp, fl);
	    dohist1 (hp->Hnext, c-1, fl);
	 }
	else
	 {
	    dohist1(hp->Hnext, c-1, fl);
	    phist(hp, fl);
	 }
}

phist(hp, fl)
  register struct Hist *hp;
  register char fl;
{

   if (! (fl & HIST_QUIET))
       xprintf("%6d\t", hp->Hnum);
   prlex(&hp->Hlex);
}
